=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpAnsibleClient
  class PulpAnsibleApiV3PluginAnsibleContentNamespacesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Provides the authentication and permission classes from settings.
    # @param distro_base_path [String] 
    # @param path [String] 
    # @param name [String] Required named, only accepts lowercase, numbers and underscores.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :company Optional namespace company owner.
    # @option opts [String] :email Optional namespace contact email.
    # @option opts [String] :description Optional short description.
    # @option opts [String] :resources Optional resource page in markdown format.
    # @option opts [Array<NamespaceLink>] :links Labeled related links.
    # @option opts [File] :avatar Optional avatar image for Namespace
    # @return [AsyncOperationResponse]
    def create(distro_base_path, path, name, opts = {})
      data, _status_code, _headers = create_with_http_info(distro_base_path, path, name, opts)
      data
    end

    # Provides the authentication and permission classes from settings.
    # @param distro_base_path [String] 
    # @param path [String] 
    # @param name [String] Required named, only accepts lowercase, numbers and underscores.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :company Optional namespace company owner.
    # @option opts [String] :email Optional namespace contact email.
    # @option opts [String] :description Optional short description.
    # @option opts [String] :resources Optional resource page in markdown format.
    # @option opts [Array<NamespaceLink>] :links Labeled related links.
    # @option opts [File] :avatar Optional avatar image for Namespace
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(distro_base_path, path, name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.create ...'
      end
      # verify the required parameter 'distro_base_path' is set
      if @api_client.config.client_side_validation && distro_base_path.nil?
        fail ArgumentError, "Missing the required parameter 'distro_base_path' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.create"
      end
      # verify the required parameter 'path' is set
      if @api_client.config.client_side_validation && path.nil?
        fail ArgumentError, "Missing the required parameter 'path' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.create"
      end
      # verify the required parameter 'name' is set
      if @api_client.config.client_side_validation && name.nil?
        fail ArgumentError, "Missing the required parameter 'name' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.create"
      end
      if @api_client.config.client_side_validation && name.to_s.length > 64
        fail ArgumentError, 'invalid value for "name" when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.create, the character length must be smaller than or equal to 64.'
      end

      if @api_client.config.client_side_validation && name.to_s.length < 3
        fail ArgumentError, 'invalid value for "name" when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.create, the character length must be great than or equal to 3.'
      end

      pattern = Regexp.new(/^(?!.*__)[a-z]+[0-9a-z_]*$/)
      if @api_client.config.client_side_validation && name !~ pattern
        fail ArgumentError, "invalid value for 'name' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.create, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'company'].nil? && opts[:'company'].to_s.length > 64
        fail ArgumentError, 'invalid value for "opts[:"company"]" when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.create, the character length must be smaller than or equal to 64.'
      end

      if @api_client.config.client_side_validation && !opts[:'email'].nil? && opts[:'email'].to_s.length > 256
        fail ArgumentError, 'invalid value for "opts[:"email"]" when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.create, the character length must be smaller than or equal to 256.'
      end

      if @api_client.config.client_side_validation && !opts[:'description'].nil? && opts[:'description'].to_s.length > 256
        fail ArgumentError, 'invalid value for "opts[:"description"]" when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.create, the character length must be smaller than or equal to 256.'
      end

      # resource path
      local_var_path = '/pulp_ansible/galaxy/{path}/api/v3/plugin/ansible/content/{distro_base_path}/namespaces/'.sub('{' + 'distro_base_path' + '}', CGI.escape(distro_base_path.to_s).gsub('%2F', '/')).sub('{' + 'path' + '}', CGI.escape(path.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['name'] = name
      form_params['company'] = opts[:'company'] if !opts[:'company'].nil?
      form_params['email'] = opts[:'email'] if !opts[:'email'].nil?
      form_params['description'] = opts[:'description'] if !opts[:'description'].nil?
      form_params['resources'] = opts[:'resources'] if !opts[:'resources'].nil?
      form_params['links'] = @api_client.build_collection_param(opts[:'links'], :csv) if !opts[:'links'].nil?
      form_params['avatar'] = opts[:'avatar'] if !opts[:'avatar'].nil?

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpAnsibleApiV3PluginAnsibleContentNamespacesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Try to remove the Namespace if no Collections under Namespace are present.
    # @param distro_base_path [String] 
    # @param name [String] 
    # @param path [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(distro_base_path, name, path, opts = {})
      data, _status_code, _headers = delete_with_http_info(distro_base_path, name, path, opts)
      data
    end

    # Try to remove the Namespace if no Collections under Namespace are present.
    # @param distro_base_path [String] 
    # @param name [String] 
    # @param path [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(distro_base_path, name, path, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.delete ...'
      end
      # verify the required parameter 'distro_base_path' is set
      if @api_client.config.client_side_validation && distro_base_path.nil?
        fail ArgumentError, "Missing the required parameter 'distro_base_path' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.delete"
      end
      # verify the required parameter 'name' is set
      if @api_client.config.client_side_validation && name.nil?
        fail ArgumentError, "Missing the required parameter 'name' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.delete"
      end
      # verify the required parameter 'path' is set
      if @api_client.config.client_side_validation && path.nil?
        fail ArgumentError, "Missing the required parameter 'path' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.delete"
      end
      # resource path
      local_var_path = '/pulp_ansible/galaxy/{path}/api/v3/plugin/ansible/content/{distro_base_path}/namespaces/{name}/'.sub('{' + 'distro_base_path' + '}', CGI.escape(distro_base_path.to_s).gsub('%2F', '/')).sub('{' + 'name' + '}', CGI.escape(name.to_s).gsub('%2F', '/')).sub('{' + 'path' + '}', CGI.escape(path.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpAnsibleApiV3PluginAnsibleContentNamespacesApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Provides the authentication and permission classes from settings.
    # @param distro_base_path [String] 
    # @param path [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :company Filter results where company matches value
    # @option opts [String] :company__contains Filter results where company contains value
    # @option opts [String] :company__icontains Filter results where company contains value
    # @option opts [String] :company__iexact Filter results where company matches value
    # @option opts [Array<String>] :company__in Filter results where company is in a comma-separated list of values
    # @option opts [String] :company__iregex Filter results where company matches regex value
    # @option opts [String] :company__istartswith Filter results where company starts with value
    # @option opts [String] :company__regex Filter results where company matches regex value
    # @option opts [String] :company__startswith Filter results where company starts with value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :metadata_sha256 Filter results where metadata_sha256 matches value
    # @option opts [Array<String>] :metadata_sha256__in Filter results where metadata_sha256 is in a comma-separated list of values
    # @option opts [String] :name Filter results where name matches value
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [String] :name__iexact Filter results where name matches value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__iregex Filter results where name matches regex value
    # @option opts [String] :name__istartswith Filter results where name starts with value
    # @option opts [String] :name__regex Filter results where name matches regex value
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;upstream_id&#x60; - Upstream id * &#x60;-upstream_id&#x60; - Upstream id (descending) * &#x60;timestamp_of_interest&#x60; - Timestamp of interest * &#x60;-timestamp_of_interest&#x60; - Timestamp of interest (descending) * &#x60;name&#x60; - Name * &#x60;-name&#x60; - Name (descending) * &#x60;company&#x60; - Company * &#x60;-company&#x60; - Company (descending) * &#x60;email&#x60; - Email * &#x60;-email&#x60; - Email (descending) * &#x60;description&#x60; - Description * &#x60;-description&#x60; - Description (descending) * &#x60;resources&#x60; - Resources * &#x60;-resources&#x60; - Resources (descending) * &#x60;links&#x60; - Links * &#x60;-links&#x60; - Links (descending) * &#x60;avatar_sha256&#x60; - Avatar sha256 * &#x60;-avatar_sha256&#x60; - Avatar sha256 (descending) * &#x60;metadata_sha256&#x60; - Metadata sha256 * &#x60;-metadata_sha256&#x60; - Metadata sha256 (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedansibleAnsibleNamespaceMetadataResponseList]
    def list(distro_base_path, path, opts = {})
      data, _status_code, _headers = list_with_http_info(distro_base_path, path, opts)
      data
    end

    # Provides the authentication and permission classes from settings.
    # @param distro_base_path [String] 
    # @param path [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :company Filter results where company matches value
    # @option opts [String] :company__contains Filter results where company contains value
    # @option opts [String] :company__icontains Filter results where company contains value
    # @option opts [String] :company__iexact Filter results where company matches value
    # @option opts [Array<String>] :company__in Filter results where company is in a comma-separated list of values
    # @option opts [String] :company__iregex Filter results where company matches regex value
    # @option opts [String] :company__istartswith Filter results where company starts with value
    # @option opts [String] :company__regex Filter results where company matches regex value
    # @option opts [String] :company__startswith Filter results where company starts with value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :metadata_sha256 Filter results where metadata_sha256 matches value
    # @option opts [Array<String>] :metadata_sha256__in Filter results where metadata_sha256 is in a comma-separated list of values
    # @option opts [String] :name Filter results where name matches value
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [String] :name__iexact Filter results where name matches value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__iregex Filter results where name matches regex value
    # @option opts [String] :name__istartswith Filter results where name starts with value
    # @option opts [String] :name__regex Filter results where name matches regex value
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;upstream_id&#x60; - Upstream id * &#x60;-upstream_id&#x60; - Upstream id (descending) * &#x60;timestamp_of_interest&#x60; - Timestamp of interest * &#x60;-timestamp_of_interest&#x60; - Timestamp of interest (descending) * &#x60;name&#x60; - Name * &#x60;-name&#x60; - Name (descending) * &#x60;company&#x60; - Company * &#x60;-company&#x60; - Company (descending) * &#x60;email&#x60; - Email * &#x60;-email&#x60; - Email (descending) * &#x60;description&#x60; - Description * &#x60;-description&#x60; - Description (descending) * &#x60;resources&#x60; - Resources * &#x60;-resources&#x60; - Resources (descending) * &#x60;links&#x60; - Links * &#x60;-links&#x60; - Links (descending) * &#x60;avatar_sha256&#x60; - Avatar sha256 * &#x60;-avatar_sha256&#x60; - Avatar sha256 (descending) * &#x60;metadata_sha256&#x60; - Metadata sha256 * &#x60;-metadata_sha256&#x60; - Metadata sha256 (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedansibleAnsibleNamespaceMetadataResponseList, Integer, Hash)>] PaginatedansibleAnsibleNamespaceMetadataResponseList data, response status code and response headers
    def list_with_http_info(distro_base_path, path, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.list ...'
      end
      # verify the required parameter 'distro_base_path' is set
      if @api_client.config.client_side_validation && distro_base_path.nil?
        fail ArgumentError, "Missing the required parameter 'distro_base_path' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.list"
      end
      # verify the required parameter 'path' is set
      if @api_client.config.client_side_validation && path.nil?
        fail ArgumentError, "Missing the required parameter 'path' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.list"
      end
      allowable_values = ["-avatar_sha256", "-company", "-description", "-email", "-links", "-metadata_sha256", "-name", "-pk", "-pulp_created", "-pulp_id", "-pulp_last_updated", "-pulp_type", "-resources", "-timestamp_of_interest", "-upstream_id", "avatar_sha256", "company", "description", "email", "links", "metadata_sha256", "name", "pk", "pulp_created", "pulp_id", "pulp_last_updated", "pulp_type", "resources", "timestamp_of_interest", "upstream_id"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp_ansible/galaxy/{path}/api/v3/plugin/ansible/content/{distro_base_path}/namespaces/'.sub('{' + 'distro_base_path' + '}', CGI.escape(distro_base_path.to_s).gsub('%2F', '/')).sub('{' + 'path' + '}', CGI.escape(path.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'company'] = opts[:'company'] if !opts[:'company'].nil?
      query_params[:'company__contains'] = opts[:'company__contains'] if !opts[:'company__contains'].nil?
      query_params[:'company__icontains'] = opts[:'company__icontains'] if !opts[:'company__icontains'].nil?
      query_params[:'company__iexact'] = opts[:'company__iexact'] if !opts[:'company__iexact'].nil?
      query_params[:'company__in'] = @api_client.build_collection_param(opts[:'company__in'], :csv) if !opts[:'company__in'].nil?
      query_params[:'company__iregex'] = opts[:'company__iregex'] if !opts[:'company__iregex'].nil?
      query_params[:'company__istartswith'] = opts[:'company__istartswith'] if !opts[:'company__istartswith'].nil?
      query_params[:'company__regex'] = opts[:'company__regex'] if !opts[:'company__regex'].nil?
      query_params[:'company__startswith'] = opts[:'company__startswith'] if !opts[:'company__startswith'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'metadata_sha256'] = opts[:'metadata_sha256'] if !opts[:'metadata_sha256'].nil?
      query_params[:'metadata_sha256__in'] = @api_client.build_collection_param(opts[:'metadata_sha256__in'], :csv) if !opts[:'metadata_sha256__in'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__iexact'] = opts[:'name__iexact'] if !opts[:'name__iexact'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__iregex'] = opts[:'name__iregex'] if !opts[:'name__iregex'].nil?
      query_params[:'name__istartswith'] = opts[:'name__istartswith'] if !opts[:'name__istartswith'].nil?
      query_params[:'name__regex'] = opts[:'name__regex'] if !opts[:'name__regex'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'pulp_href__in'] = @api_client.build_collection_param(opts[:'pulp_href__in'], :csv) if !opts[:'pulp_href__in'].nil?
      query_params[:'pulp_id__in'] = @api_client.build_collection_param(opts[:'pulp_id__in'], :csv) if !opts[:'pulp_id__in'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedansibleAnsibleNamespaceMetadataResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpAnsibleApiV3PluginAnsibleContentNamespacesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Provides the authentication and permission classes from settings.
    # @param distro_base_path [String] 
    # @param name [String] 
    # @param path [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Required named, only accepts lowercase, numbers and underscores.
    # @option opts [String] :company Optional namespace company owner.
    # @option opts [String] :email Optional namespace contact email.
    # @option opts [String] :description Optional short description.
    # @option opts [String] :resources Optional resource page in markdown format.
    # @option opts [Array<NamespaceLink>] :links Labeled related links.
    # @option opts [File] :avatar Optional avatar image for Namespace
    # @return [AsyncOperationResponse]
    def partial_update(distro_base_path, name, path, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(distro_base_path, name, path, opts)
      data
    end

    # Provides the authentication and permission classes from settings.
    # @param distro_base_path [String] 
    # @param name [String] 
    # @param path [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name Required named, only accepts lowercase, numbers and underscores.
    # @option opts [String] :company Optional namespace company owner.
    # @option opts [String] :email Optional namespace contact email.
    # @option opts [String] :description Optional short description.
    # @option opts [String] :resources Optional resource page in markdown format.
    # @option opts [Array<NamespaceLink>] :links Labeled related links.
    # @option opts [File] :avatar Optional avatar image for Namespace
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(distro_base_path, name, path, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.partial_update ...'
      end
      # verify the required parameter 'distro_base_path' is set
      if @api_client.config.client_side_validation && distro_base_path.nil?
        fail ArgumentError, "Missing the required parameter 'distro_base_path' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.partial_update"
      end
      # verify the required parameter 'name' is set
      if @api_client.config.client_side_validation && name.nil?
        fail ArgumentError, "Missing the required parameter 'name' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.partial_update"
      end
      # verify the required parameter 'path' is set
      if @api_client.config.client_side_validation && path.nil?
        fail ArgumentError, "Missing the required parameter 'path' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.partial_update"
      end
      if @api_client.config.client_side_validation && !opts[:'name'].nil? && opts[:'name'].to_s.length > 64
        fail ArgumentError, 'invalid value for "opts[:"name"]" when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.partial_update, the character length must be smaller than or equal to 64.'
      end

      if @api_client.config.client_side_validation && !opts[:'name'].nil? && opts[:'name'].to_s.length < 3
        fail ArgumentError, 'invalid value for "opts[:"name"]" when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.partial_update, the character length must be great than or equal to 3.'
      end

      pattern = Regexp.new(/^(?!.*__)[a-z]+[0-9a-z_]*$/)
      if @api_client.config.client_side_validation && !opts[:'name'].nil? && opts[:'name'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"name\"]' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.partial_update, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'company'].nil? && opts[:'company'].to_s.length > 64
        fail ArgumentError, 'invalid value for "opts[:"company"]" when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.partial_update, the character length must be smaller than or equal to 64.'
      end

      if @api_client.config.client_side_validation && !opts[:'email'].nil? && opts[:'email'].to_s.length > 256
        fail ArgumentError, 'invalid value for "opts[:"email"]" when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.partial_update, the character length must be smaller than or equal to 256.'
      end

      if @api_client.config.client_side_validation && !opts[:'description'].nil? && opts[:'description'].to_s.length > 256
        fail ArgumentError, 'invalid value for "opts[:"description"]" when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.partial_update, the character length must be smaller than or equal to 256.'
      end

      # resource path
      local_var_path = '/pulp_ansible/galaxy/{path}/api/v3/plugin/ansible/content/{distro_base_path}/namespaces/{name}/'.sub('{' + 'distro_base_path' + '}', CGI.escape(distro_base_path.to_s).gsub('%2F', '/')).sub('{' + 'name' + '}', CGI.escape(name.to_s).gsub('%2F', '/')).sub('{' + 'path' + '}', CGI.escape(path.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['name'] = opts[:'name'] if !opts[:'name'].nil?
      form_params['company'] = opts[:'company'] if !opts[:'company'].nil?
      form_params['email'] = opts[:'email'] if !opts[:'email'].nil?
      form_params['description'] = opts[:'description'] if !opts[:'description'].nil?
      form_params['resources'] = opts[:'resources'] if !opts[:'resources'].nil?
      form_params['links'] = @api_client.build_collection_param(opts[:'links'], :csv) if !opts[:'links'].nil?
      form_params['avatar'] = opts[:'avatar'] if !opts[:'avatar'].nil?

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpAnsibleApiV3PluginAnsibleContentNamespacesApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Provides the authentication and permission classes from settings.
    # @param distro_base_path [String] 
    # @param name [String] 
    # @param path [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [AnsibleAnsibleNamespaceMetadataResponse]
    def read(distro_base_path, name, path, opts = {})
      data, _status_code, _headers = read_with_http_info(distro_base_path, name, path, opts)
      data
    end

    # Provides the authentication and permission classes from settings.
    # @param distro_base_path [String] 
    # @param name [String] 
    # @param path [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(AnsibleAnsibleNamespaceMetadataResponse, Integer, Hash)>] AnsibleAnsibleNamespaceMetadataResponse data, response status code and response headers
    def read_with_http_info(distro_base_path, name, path, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.read ...'
      end
      # verify the required parameter 'distro_base_path' is set
      if @api_client.config.client_side_validation && distro_base_path.nil?
        fail ArgumentError, "Missing the required parameter 'distro_base_path' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.read"
      end
      # verify the required parameter 'name' is set
      if @api_client.config.client_side_validation && name.nil?
        fail ArgumentError, "Missing the required parameter 'name' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.read"
      end
      # verify the required parameter 'path' is set
      if @api_client.config.client_side_validation && path.nil?
        fail ArgumentError, "Missing the required parameter 'path' when calling PulpAnsibleApiV3PluginAnsibleContentNamespacesApi.read"
      end
      # resource path
      local_var_path = '/pulp_ansible/galaxy/{path}/api/v3/plugin/ansible/content/{distro_base_path}/namespaces/{name}/'.sub('{' + 'distro_base_path' + '}', CGI.escape(distro_base_path.to_s).gsub('%2F', '/')).sub('{' + 'name' + '}', CGI.escape(name.to_s).gsub('%2F', '/')).sub('{' + 'path' + '}', CGI.escape(path.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AnsibleAnsibleNamespaceMetadataResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpAnsibleApiV3PluginAnsibleContentNamespacesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
