=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpAnsibleClient
  class PulpAnsibleDefaultApiV3PluginAnsibleSearchCollectionVersionsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # A viewset for cross-repo searches.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :dependency 
    # @option opts [Boolean] :deprecated 
    # @option opts [Array<String>] :distribution Filter collectionversions that are in these distrubtion ids.
    # @option opts [Array<String>] :distribution_base_path Filter collectionversions that are in these base paths.
    # @option opts [Boolean] :highest 
    # @option opts [Boolean] :is_deprecated 
    # @option opts [Boolean] :is_highest 
    # @option opts [Boolean] :is_signed 
    # @option opts [String] :keywords 
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :namespace 
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :order_by Ordering  * &#x60;pulp_created&#x60; - by CV created * &#x60;-pulp_created&#x60; - by CV created (descending) * &#x60;namespace&#x60; - by CV namespace * &#x60;-namespace&#x60; - by CV namespace (descending) * &#x60;name&#x60; - by CV name * &#x60;-name&#x60; - by CV name (descending) * &#x60;version&#x60; - by CV version * &#x60;-version&#x60; - by CV version (descending)
    # @option opts [String] :q 
    # @option opts [Array<String>] :repository Filter collectionversions that are in these repository ids.
    # @option opts [String] :repository_label Filter labels by search string
    # @option opts [Array<String>] :repository_name Filter collectionversions that are in these repositories.
    # @option opts [String] :repository_version 
    # @option opts [Boolean] :signed 
    # @option opts [String] :tags Filter by comma separate list of tags that must all be matched
    # @option opts [String] :version 
    # @option opts [String] :version_range 
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedCollectionVersionSearchListResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # A viewset for cross-repo searches.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :dependency 
    # @option opts [Boolean] :deprecated 
    # @option opts [Array<String>] :distribution Filter collectionversions that are in these distrubtion ids.
    # @option opts [Array<String>] :distribution_base_path Filter collectionversions that are in these base paths.
    # @option opts [Boolean] :highest 
    # @option opts [Boolean] :is_deprecated 
    # @option opts [Boolean] :is_highest 
    # @option opts [Boolean] :is_signed 
    # @option opts [String] :keywords 
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :namespace 
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :order_by Ordering  * &#x60;pulp_created&#x60; - by CV created * &#x60;-pulp_created&#x60; - by CV created (descending) * &#x60;namespace&#x60; - by CV namespace * &#x60;-namespace&#x60; - by CV namespace (descending) * &#x60;name&#x60; - by CV name * &#x60;-name&#x60; - by CV name (descending) * &#x60;version&#x60; - by CV version * &#x60;-version&#x60; - by CV version (descending)
    # @option opts [String] :q 
    # @option opts [Array<String>] :repository Filter collectionversions that are in these repository ids.
    # @option opts [String] :repository_label Filter labels by search string
    # @option opts [Array<String>] :repository_name Filter collectionversions that are in these repositories.
    # @option opts [String] :repository_version 
    # @option opts [Boolean] :signed 
    # @option opts [String] :tags Filter by comma separate list of tags that must all be matched
    # @option opts [String] :version 
    # @option opts [String] :version_range 
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedCollectionVersionSearchListResponseList, Integer, Hash)>] PaginatedCollectionVersionSearchListResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpAnsibleDefaultApiV3PluginAnsibleSearchCollectionVersionsApi.list ...'
      end
      allowable_values = ["-name", "-namespace", "-pulp_created", "-version", "name", "namespace", "pulp_created", "version"]
      if @api_client.config.client_side_validation && opts[:'order_by'] && !opts[:'order_by'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"order_by\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp_ansible/galaxy/default/api/v3/plugin/ansible/search/collection-versions/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'dependency'] = opts[:'dependency'] if !opts[:'dependency'].nil?
      query_params[:'deprecated'] = opts[:'deprecated'] if !opts[:'deprecated'].nil?
      query_params[:'distribution'] = @api_client.build_collection_param(opts[:'distribution'], :multi) if !opts[:'distribution'].nil?
      query_params[:'distribution_base_path'] = @api_client.build_collection_param(opts[:'distribution_base_path'], :multi) if !opts[:'distribution_base_path'].nil?
      query_params[:'highest'] = opts[:'highest'] if !opts[:'highest'].nil?
      query_params[:'is_deprecated'] = opts[:'is_deprecated'] if !opts[:'is_deprecated'].nil?
      query_params[:'is_highest'] = opts[:'is_highest'] if !opts[:'is_highest'].nil?
      query_params[:'is_signed'] = opts[:'is_signed'] if !opts[:'is_signed'].nil?
      query_params[:'keywords'] = opts[:'keywords'] if !opts[:'keywords'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'namespace'] = opts[:'namespace'] if !opts[:'namespace'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'order_by'] = @api_client.build_collection_param(opts[:'order_by'], :csv) if !opts[:'order_by'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'repository'] = @api_client.build_collection_param(opts[:'repository'], :multi) if !opts[:'repository'].nil?
      query_params[:'repository_label'] = opts[:'repository_label'] if !opts[:'repository_label'].nil?
      query_params[:'repository_name'] = @api_client.build_collection_param(opts[:'repository_name'], :multi) if !opts[:'repository_name'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'signed'] = opts[:'signed'] if !opts[:'signed'].nil?
      query_params[:'tags'] = opts[:'tags'] if !opts[:'tags'].nil?
      query_params[:'version'] = opts[:'version'] if !opts[:'version'].nil?
      query_params[:'version_range'] = opts[:'version_range'] if !opts[:'version_range'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedCollectionVersionSearchListResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpAnsibleDefaultApiV3PluginAnsibleSearchCollectionVersionsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # A viewset for cross-repo searches.
    # @param collection_version_search_list [CollectionVersionSearchList] 
    # @param [Hash] opts the optional parameters
    # @return [CollectionVersionSearchListResponse]
    def rebuild(collection_version_search_list, opts = {})
      data, _status_code, _headers = rebuild_with_http_info(collection_version_search_list, opts)
      data
    end

    # A viewset for cross-repo searches.
    # @param collection_version_search_list [CollectionVersionSearchList] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CollectionVersionSearchListResponse, Integer, Hash)>] CollectionVersionSearchListResponse data, response status code and response headers
    def rebuild_with_http_info(collection_version_search_list, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpAnsibleDefaultApiV3PluginAnsibleSearchCollectionVersionsApi.rebuild ...'
      end
      # verify the required parameter 'collection_version_search_list' is set
      if @api_client.config.client_side_validation && collection_version_search_list.nil?
        fail ArgumentError, "Missing the required parameter 'collection_version_search_list' when calling PulpAnsibleDefaultApiV3PluginAnsibleSearchCollectionVersionsApi.rebuild"
      end
      # resource path
      local_var_path = '/pulp_ansible/galaxy/default/api/v3/plugin/ansible/search/collection-versions/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(collection_version_search_list) 

      # return_type
      return_type = opts[:return_type] || 'CollectionVersionSearchListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpAnsibleDefaultApiV3PluginAnsibleSearchCollectionVersionsApi#rebuild\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
