=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module PulpAnsibleClient
  # Collection Version serializer without docs blob.
  class CollectionSummaryResponse
    attr_accessor :pulp_href

    # The namespace of the collection.
    attr_accessor :namespace

    # The name of the collection.
    attr_accessor :name

    # The version of the collection.
    attr_accessor :version

    # The version of Ansible required to use the collection. Multiple versions can be separated with a comma.
    attr_accessor :requires_ansible

    # Timestamp of creation.
    attr_accessor :pulp_created

    # A JSON field with data about the contents.
    attr_accessor :contents

    # A dict declaring Collections that this collection requires to be installed for it to be usable.
    attr_accessor :dependencies

    # A short summary description of the collection.
    attr_accessor :description

    attr_accessor :tags

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'pulp_href' => :'pulp_href',
        :'namespace' => :'namespace',
        :'name' => :'name',
        :'version' => :'version',
        :'requires_ansible' => :'requires_ansible',
        :'pulp_created' => :'pulp_created',
        :'contents' => :'contents',
        :'dependencies' => :'dependencies',
        :'description' => :'description',
        :'tags' => :'tags'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'pulp_href' => :'String',
        :'namespace' => :'String',
        :'name' => :'String',
        :'version' => :'String',
        :'requires_ansible' => :'String',
        :'pulp_created' => :'DateTime',
        :'contents' => :'Object',
        :'dependencies' => :'Object',
        :'description' => :'String',
        :'tags' => :'Array<AnsibleTagResponse>'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'requires_ansible',
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `PulpAnsibleClient::CollectionSummaryResponse` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `PulpAnsibleClient::CollectionSummaryResponse`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'pulp_href')
        self.pulp_href = attributes[:'pulp_href']
      end

      if attributes.key?(:'namespace')
        self.namespace = attributes[:'namespace']
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'version')
        self.version = attributes[:'version']
      end

      if attributes.key?(:'requires_ansible')
        self.requires_ansible = attributes[:'requires_ansible']
      end

      if attributes.key?(:'pulp_created')
        self.pulp_created = attributes[:'pulp_created']
      end

      if attributes.key?(:'contents')
        self.contents = attributes[:'contents']
      end

      if attributes.key?(:'dependencies')
        self.dependencies = attributes[:'dependencies']
      end

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.key?(:'tags')
        if (value = attributes[:'tags']).is_a?(Array)
          self.tags = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@namespace.nil? && @namespace.to_s.length > 64
        invalid_properties.push('invalid value for "namespace", the character length must be smaller than or equal to 64.')
      end

      if !@name.nil? && @name.to_s.length > 64
        invalid_properties.push('invalid value for "name", the character length must be smaller than or equal to 64.')
      end

      if !@version.nil? && @version.to_s.length > 128
        invalid_properties.push('invalid value for "version", the character length must be smaller than or equal to 128.')
      end

      if !@requires_ansible.nil? && @requires_ansible.to_s.length > 255
        invalid_properties.push('invalid value for "requires_ansible", the character length must be smaller than or equal to 255.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@namespace.nil? && @namespace.to_s.length > 64
      return false if !@name.nil? && @name.to_s.length > 64
      return false if !@version.nil? && @version.to_s.length > 128
      return false if !@requires_ansible.nil? && @requires_ansible.to_s.length > 255
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] namespace Value to be assigned
    def namespace=(namespace)
      if !namespace.nil? && namespace.to_s.length > 64
        fail ArgumentError, 'invalid value for "namespace", the character length must be smaller than or equal to 64.'
      end

      @namespace = namespace
    end

    # Custom attribute writer method with validation
    # @param [Object] name Value to be assigned
    def name=(name)
      if !name.nil? && name.to_s.length > 64
        fail ArgumentError, 'invalid value for "name", the character length must be smaller than or equal to 64.'
      end

      @name = name
    end

    # Custom attribute writer method with validation
    # @param [Object] version Value to be assigned
    def version=(version)
      if !version.nil? && version.to_s.length > 128
        fail ArgumentError, 'invalid value for "version", the character length must be smaller than or equal to 128.'
      end

      @version = version
    end

    # Custom attribute writer method with validation
    # @param [Object] requires_ansible Value to be assigned
    def requires_ansible=(requires_ansible)
      if !requires_ansible.nil? && requires_ansible.to_s.length > 255
        fail ArgumentError, 'invalid value for "requires_ansible", the character length must be smaller than or equal to 255.'
      end

      @requires_ansible = requires_ansible
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          pulp_href == o.pulp_href &&
          namespace == o.namespace &&
          name == o.name &&
          version == o.version &&
          requires_ansible == o.requires_ansible &&
          pulp_created == o.pulp_created &&
          contents == o.contents &&
          dependencies == o.dependencies &&
          description == o.description &&
          tags == o.tags
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [pulp_href, namespace, name, version, requires_ansible, pulp_created, contents, dependencies, description, tags].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        PulpAnsibleClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
